'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : [select VIEW...EDITOR OPTIONS]                    *
'*  Notice  : Copyright (c) 2015 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 19/04/2015                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************



Device 18F4550


    Xtal 8
    

    
    Declare Hserial_Baud 19200
    Declare Hserial_RCSTA = %10010000  ' Enable serial port and continuous receive
    Declare Hserial_TXSTA = %00100000  ' Enable transmit and asynchronous mode2 
    Declare Hserial_Clear = On         ' OptionaLL2y clear the buffer before receiving
                                
    

    
    All_Digital true
    
    Declare Bootloader OFF

 '----------------------------------------------------------------------------------------------------------------------------------------****    


Config_Start


    FOSC = INTOSC_XT
    MCLRE=Off
    PLLDIV=1
    VREGEN = On
    WDT=OFF
    CPUDIV=OSC1_PLL2
    USBDIV=2

   Config_End   

   
   Reminders off
   
   Declare Float_Display_Type = LARGE
   
   Include "CDC_Descriptor.inc"
   
     
    
    OSCCON.0=0
    OSCCON.1=0
    OSCCON.2=1
    OSCCON.3=1
    OSCCON.4=1                   
    OSCCON.5=1
    OSCCON.6=1
    OSCCON.7=0
    
    OSCTUNE.0=1
    OSCTUNE.1=1
    OSCTUNE.2=1
    OSCTUNE.3=1
    OSCTUNE.4=0

    OSCTUNE.7=0 
  

    TRISA=%11100000
    TRISB=%11000000
    TRISC=%10111000
    TRISD=%00101000

     TRISE.0 = 1
     TRISE.1 = 1
     TRISE.2 = 1
    
      UCFG.6 = 0
      UCFG.3 = 0
      
      INTCON.7 = 0
      INTCON.6 = 0
      INTCON.5 = 0
      INTCON.4 = 0
      INTCON.3 = 0
      INTCON.2 = 0
      INTCON.1 = 0
      INTCON.0 = 0
    
    ADCON1=%00000000              
    ADCON2=%10110101                  
    
    ADCON2.7=1
'----------------------------------------------------------------------------------------------------------------------------------------***
'HPWM 1, 0, 0                    ' enable Hardware PWM for backlight and set to o% duty cycle
'---------------------------------------------------------------------------------------------------------------------------------------- 
SYMBOLS:                        ' Alias port pins







Symbol MEASUREHART             = LATA.0
Symbol MEASURE24V              = LATA.1
Symbol MEASUREmA               = LATA.2
Symbol MEASUREmVRTD            = LATA.3
Symbol MEASURE34RDT            = LATA.4

Symbol AUX1TOP                 = LATB.0
Symbol AUX1BOTTOM              = LATB.1
Symbol AUX4TOP                 = LATB.2
Symbol AUX2TOP                 = LATB.3
Symbol AUX3TOP                 = LATB.4
Symbol AUX2BOTTOM              = LATB.5

Symbol MEASUREThermocouple     = LATC.0
Symbol SOURCEThermocouple      = LATC.1
Symbol LED                     = LATC.2

Symbol RELAY2                  = LATD.0

Symbol SOURCEOhms              = LATD.1
Symbol SOURCEVmA               = LATD.2

Symbol RELAY1                  = LATD.4

Symbol AUX3BOTTOM              = LATD.6
Symbol AUX4BOTTOM              = LATD.7




'---------------------------------------------------------------------------------------------------------------------------------------- 




MEASUREHART                    = 0
MEASURE24V                     = 0
MEASUREmA                      = 0
MEASUREmVRTD                   = 0
MEASURE34RDT                   = 0

AUX1TOP                        = 0
AUX2TOP                        = 0
AUX1BOTTOM                     = 0
AUX4TOP                        = 0
AUX3TOP                        = 0
AUX2BOTTOM                     = 0

MEASUREThermocouple            = 0
SOURCEThermocouple             = 0
LED                             = 0

RELAY2                          = 0

SOURCEOhms                     = 0
SOURCEVmA                      = 0

RELAY1                          = 0

AUX3BOTTOM                     = 0
AUX4BOTTOM                     = 0



DIMS: 

BITS:



Dim Skip_Temp_MAXMIN                As Bit      ' If set then don't update the maxmin

Dim DATA_OUTPUT_TYPE                As Bit



Dim Temperature_Reset_Requested     As Bit      ' If a reset has been issued then clear everything


Dim Sensor_Errored                  As Bit      ' Once a sensor error has occured then set this flag so as not to cycle the backlight

Dim Sensor_Error_Flag               As Bit      ' If there is no temp sensor then raise the flag so the text can be removed when it is connected
Dim Sensor_Error_Flag2              As Bit      ' When there is no temp sensor then do this only once!

Dim Portable                        As Bit      ' Portable of Panel fitted

Dim Restart_Latch                   As Bit      
Dim Restart_Latch2                  As Bit



Dim Inhibit_Arrows                  As Bit      ' For use in soft menu navigation

Dim Overload                        As Bit      ' If the sensor produces overload then start alarming and don't do any conversion

Dim Toggle_Zero                     As Bit      ' Zero offset toggle bit 0 = 0, 1 = reading of sensor 

Dim Test_Flag                       As Bit

Dim Filter                          As Bit      ' FILTER ON/OFF bit
Dim Filter_Latch                    As Bit      ' Turn off Filter for one cycle
Dim Filter_Latch2                   As Bit      ' Refresh the Display when changing units



Dim No_CONNECTION_Flag              As Bit      ' Flag for POD disconnection

Dim Input_Data_Type                 As Bit      ' Display or PC? 0 = PC, 1 = Display


Dim Temp_On                         As Bit      ' Temp broadcast bit     


Dim Temp_Offset_Request             As Bit      ' If offset has changed then apply when at suitable point to avoid false readings       


Dim Restart_Requested               As Bit      ' If restarted then cycle and restart the display
   



Dim MaxMin                          As Bit      ' Toggle flag for Max Min On/Off

Dim I2C_First_Run                   As Bit      ' Only set this on power up, this stops print output when running. (Test I2C connection)

Dim SHT20_ACTIVE                    As Bit
Dim MCP9700_ACTIVE                  As Bit

Dim I2C_OK                          As Bit      ' If I2C connection is ok then set this flag

BYTES:


Dim DIG0                            As Byte
Dim DIG1                            As Byte
Dim DIG2                            As Byte
Dim DIG3                            As Byte
Dim DIG4                            As Byte
Dim DIG5                            As Byte
Dim DIG6                            As Byte
Dim DIG7                            As Byte
Dim DIG8                            As Byte
Dim DIG9                            As Byte
Dim DIG10                           As Byte
Dim DIG11                           As Byte
Dim DIG12                           As Byte
Dim DIG13                           As Byte
Dim DIG14                           As Byte
Dim DIG15                           As Byte

Dim MEASURE_HART_FLASH              As Byte
Dim MEASURE_24V_FLASH               As Byte
Dim MEASURE_mA_FLASH                As Byte
Dim MEASURE_mVRTD_FLASH             As Byte
Dim MEASURE_34RDT_FLASH             As Byte

Dim AUX1_TOP_FLASH                  As Byte
Dim AUX1_BOTTOM_FLASH               As Byte
Dim AUX4_TOP_FLASH                  As Byte
Dim AUX3_TOP_FLASH                  As Byte
Dim AUX2_BOTTOM_FLASH               As Byte

Dim MEASURE_Thermocouple_FLASH      As Byte
Dim SOURCE_Thermocouple_FLASH       As Byte          

Dim SOURCE_Ohms_FLASH               As Byte
Dim SOURCE_VmA_FLASH                As Byte

Dim AUX3_BOTTOM_FLASH               As Byte
Dim AUX4_BOTTOM_FLASH               As Byte


Dim Dig_Bit                         As Byte

Dim LED_BIT                         As Byte

Dim Sensor_Type                     As Byte

Dim BMP_Data_Loops                  As Byte     ' Number of times we look at the register.



Dim I2C_Byte1                       As Byte
Dim I2C_Byte2                       As Byte
Dim I2C_Byte3                       As Byte

Dim Restart_Counter                 As Byte     ' Counter to apply changes in calibration


Dim Rounding_Byte                   As Byte     ' When recieving byte value via RS232 for brightness and volume round to nearest usable value
  

Dim Decimal_Places                  As Byte     ' Number of digits after the point
Dim Decimal_Places_Temp             As Byte     ' Temp number in case switching between sensors
Dim Decimal_Counter                 As Byte     ' Used to reverse count the string
Dim Decimal_Counter2                As Byte     ' Used to count up when running backwards




Dim Digit_Stored[9]                 As Byte     ' Left to right location of charactars
Dim Digit_Temp[9]                   As Byte     ' Left to right location of previous charactars


Dim NByte                           As Byte     ' For string/float conversion
Dim NByte2                          As Byte     ' For string/float conversion
Dim BUnit                           As Byte     ' For string/float conversion

Dim Max_Length                      As Byte     ' Size of Max string
Dim Min_Length                      As Byte     ' Size of Min String


Dim Reading_Max_Neg                 As Byte     ' Is max a negative figure?
Dim Reading_Min_Neg                 As Byte     ' Is Min a negative figure?



Dim Unit                            As Byte     ' The current unit selected e.g. mmH20
Dim Unit_Temp                       As Byte     ' A temporary version so as to switch back after zeroing



Dim Buttons                         As Byte     ' for keypad detection

Dim Plus_or_Minus                   As Byte     ' Plus of minus figure

Dim BaudDetected                    As Byte     ' Baud speed detected (POD)


Dim Range                           As Byte     ' Range Mode (moves the decimal point etc..)

Dim Mode                            As Byte     'Choose which mode to run (1=Temp, 2=Pressure, Etc..)

Dim Centigrade                      As Byte

Dim Channel                         As Byte     ' Input Channel


Dim Cycle_Speed                     As Byte     ' Speed at which the display cycles the backlight

Dim Max_Temp_Bit                    As Byte     ' If changed flag to reduce code
Dim Min_Temp_Bit                    As Byte     ' If changed flag to reduce code
Dim Temp_Divider_Bit                As Byte     ' If changed flag to reduce code
Dim Temp_Offset_Bit                 As Byte     ' If changed flag to reduce code
Dim Temp_Centigrade_Bit             As Byte     ' If changed flag to reduce code
Dim HalfDegreeOffset_Bit            As Byte     ' If changed flag to reduce code
Dim Digit_Colour_Bit                As Byte     ' If changed flag to reduce code

Dim HalfDegreeOffset                As Byte     ' Tune the 1 Deg Accuracy of the sensor +/- half a degree

Dim Digit_One                       As Byte     ' 10, 20, 30 
Dim Digit_Two                       As Byte     ' 0 to 9
Dim Digit_Three                     As Byte     ' .0 to .9

Dim Digit_One_Temp                  As Byte     ' Tempory values for the above
Dim Digit_Two_Temp                  As Byte     ' Tempory values for the above
Dim Digit_Three_Temp                As Byte     ' Tempory values for the above


Dim Sensor_Data_Count_IN            As Byte     ' POD data in

Dim Byte_Array [250]                As Byte     ' Data from PC
Dim Sensor_Array [20]               As Byte     ' Data from POD
Dim Byte_Address                    As Byte     ' Location of each byte



Dim Spare_Byte                      As Byte     ' Spare bytes
Dim Spare_Byte2                     As Byte     ' Spare bytes
Dim Spare_Byte3                     As Byte     ' Spare bytes
Dim Spare_Byte4                     As Byte     ' Spare bytes


Dim Reading_Array_Length            As Byte     ' Length of reading
Dim Reading_Array_Length2           As Byte     ' lenght of reading for comparison
Dim Reading_Array [10]              As Byte     ' Reading data



Dim Seconds                         As Byte     ' Counted seconds to 60 then incriment Minutes
Dim Minutes                         As Byte     ' Minutes counted

Dim A11                             As Byte     ' Display Data tempory variable

Dim Display_Data_Counter            As Byte     ' Counter within the array

Dim Comma_Counter                   As Byte     ' How many commas are in the string

Dim Number_Counter                  As Byte     ' Number of digits in a string that are between "0" and "9" 

Dim Number_Byte_Array [6]           As Byte     ' For converting the numbers

Dim Filter_TIME                     As Byte     ' Sample and average time
Dim Filter_BAND                     As Byte     ' Band width from average for used samples

Dim Filter_Counter                  As Byte     ' Number of elapsed cycles for applying filter



Dim POWER_Minutes_Set               As Byte     ' Power off Minutes

Dim Powersave_Minutes               As Byte     ' Minutes counting up from last button press

Dim Random_Byte                     As Byte
Dim Random_Byte2                    As Byte

Dim Data_Value_Array[5]             As Byte

WORDS:    

Dim Flash_Counter                   As Word     ' Main code loops counter to get 2 x 500ms

Dim Print_Reading_Counter           As Word     ' Frequency at which the reading gets updated    

Dim BMP_Address                     As Word     ' BMP Address of Register
Dim BMP_Read_Address                As Word     ' e.g. F6(Temp/Pressure) or AA(EEPROM)

  
Dim Frequency                       As Word     ' Tone frequency
Dim Top_Frequency                   As Word     ' Top end frequency
Dim Bottom_Frequency                As Word     ' Bottom end frequency
Dim Beep_Time                       As Word     ' Duration of the tone  
Dim Rise_Speed                      As Word     ' Speed of which tone changes   


Dim Start_Seconds                   As Word     ' Leak_Seconds before start of leak test
Dim Start_Seconds_Set               As Word     ' Leak_Seconds set before start of Leak test
Dim Seconds_Set                     As Word     ' Leak_Seconds set for leak test    


Dim Temp_Offset                     As Word     ' Offset word
Dim Temp_Offset2                    As Word     ' Offest word temp

Dim Button_Hold_Counter             As Word     ' count how long the buttons are pressed

Dim Array_Length                    As Word     ' Length of the array

Dim A1                              As Word     ' Tempory variable
Dim A2                              As Word     ' Tempory variable
Dim A3                              As Word     ' Tempory variable
Dim A4                              As Word     ' Tempory variable

Dim A5                              As Word     ' Tempory variable

Dim A6                              As Word     ' Tempory variable

Dim Data_Counter                    As Word     ' Data bytes comming in

Dim Max_Temp                        As Word     ' Max temperature
Dim Min_Temp                        As Word     ' Min tempurature


Dim Data_Count_IN                   As Word     ' total bytes counted in
Dim Temp                            As Word     ' The temperature
Dim Temp_Temp                       As Word     ' temperature to compare to temp to see if change has occured

Dim Temp_divider                    As Word     ' Divider for calibration


Dim Reading_Actual                  As Word     ' Raw calculated reading
Dim Temp_Raw                        As Word     ' Temporary raw reading
Dim Temp_Raw2                       As Word     ' Second temporary raw reading
Dim Temp2                           As Word     ' tempory temperature value for calculation
Dim Temp3                           As Word     ' tempory temperature value for calculation
Dim Temp4                           As Word     ' tempory temperature value for calculation


Dim BaudMode                        As Word     ' Data rate for POD connection
Dim BaudMode2                       As Word     ' Temporary data rate for POD connection

Dim Multiplier2                     As Word     ' unit calculation


Dim Settle_Counter                  As Word     ' delay before displaying reading to allow averaging to occur

Dim No_Connection_Counter           As Word     ' Timeout for no connection with POD
Dim Connection_Counter              As Word     ' Count the connection if comms lost

Dim Out_of_Range_Counter            As Word     ' If out of range then start counting

Dim Product_Code                    As Word     ' The product number e.g. 9722 for Temps Sense Mini

Dim RH                              As Word     ' RH iniital reading 

Dim BMP                             As Word     ' BMP085 Initial reading

Dim RAW                             As Word     ' Raw reading from ADC

Dim DATA_Value_Word                 As Word

DWORDS:
   



Dim Serial_Number                   As Dword    ' Serial number for the product

Dim Reading                         As Dword    ' Reading 

Dim Reading_True                    As Dword    ' current actual reading 
Dim Reading_Display                 As Dword    ' reading as displayed

Dim Reading_Max                     As Dword    ' Maximum reading
Dim Reading_Min                     As Dword    ' Minimum reading
Dim Reading_Max2                    As Dword    ' Temp reading
Dim Reading_Min2                    As Dword    ' Temp reading

Dim B1                              As Dword 
Dim Number_Multiplier               As Dword    ' Value to multiply the digits e.g. 1, 10, 100, 1000, 10 000 etc..
Dim Temp5                           As Dword    ' Temp Dword for calculation
Dim Overflow_Byte1                  As Byte     ' Added to stop crossing of boundary issue with compiler
Dim Temp_Raw_Stack                  As Dword    ' Temp Dword for caculation
Dim Temp_Raw_Stack2                 As Dword    ' Temp Dword for caculation


Dim Data_Value                      As Dword    ' Value from parsed string e.g Data,123 = <123>


Dim Overflow_Word1                  As Word     ' Added to stop crossing of boundary issue with compiler


Dim SHT20_Temp_LARGE                As Dword

Dim Firmware_Version                As String * 10  ' The firmware Version e.g. P99.9  


Dim Data_In                         As String *32       ' Data in as string

Dim Spare_String                    As String *10       ' Spare string for calculation


Dim String_Array_Sensor             As String *20   ' Used to ouput sensor data as string (will be removed when all input strings have been assigned)
Dim DATA_OUTPUT_STRING              As String *32

Dim LED_BIT_String                  As String *1    ' e.g. "0" or "1"

Dim I2C_StringBin8                  As String *8

FLOATS:


Dim BMP_Float                       As Float        ' Temp float for BMP calculations

Dim Temp_Divider_Float              As Float

Dim Multiplier                      As Float        ' Multipler for MFD


Dim Reading_Float                   As Float        ' The actual Reading
Dim Reading_Float_Temp              As Float        ' A tempory reading used to delete preceeding digits when value reduces

Dim Reading_Float_Zero              As Float        ' The value to be stored after Tare and after the initial reading
Dim Reading_Float_Tare              As Float        ' The value to be stored after the initial reading

Dim Zero_Offset                     As Float        ' For float/string conversion

Dim FTotal                          As Float        ' For float/string conversion

Dim FMultiplier                     As Float        ' For float/string conversion

Dim Spare_Byte19                    As Byte
Dim Spare_Byte20                    As Byte
Dim Spare_Byte21                    As Byte
Dim Spare_Byte22                    As Byte


Dim Temp_Float                      As Float        ' Temperature actual

Dim RH_Float                        As Float        ' RH temp Actual






DATA_OUTPUT_STRING =  "USBInit" + 13
GoSub DATA_OUT

Dim Byteout As Byte = $41
Dim Wordout As Word = $4142
Dim DWordout As Dword = $41424344
Dim RxBuffer[32] As Byte
Dim RX_String As String * 32
Dim TxBuffer As String * 32 
Dim Buffer_Length As Byte
Dim Status_Latch As Bit = 0
Dim USB_Byte_Array[32] As Byte

'----------------------------------------------------------------------------------------------------------------------------------------***
DelayMS 10
USBInit
A1 = 0
A2 = 0
DelayMS 3000
'----------------------------------------------------------------------------------------------------------------------------------------***


'----------------------------------------------------------------------------------------------------------------------------------------    


set_varables:


DATA_OUTPUT_TYPE        = 0 '1 = USB 0 = RS232

Sensor_Errored          = 0

Sensor_Error_Flag       = 0
Sensor_Error_Flag2      = 0

Restart_Latch           = 0

Inhibit_Arrows          = 0



Toggle_Zero             = 0 'Turn it off initially

Filter_Latch            = 0
Filter_Latch2           = 0

No_CONNECTION_Flag      = 0

MaxMin                  = 0



Input_Data_Type         = 0


Temp_On                 = 0

Temp_Offset_Request     = 0

Centigrade              = 1
HalfDegreeOffset        = 50

Temp_Divider_Bit        = 0
Temp_Offset_Bit         = 0
Max_Temp_Bit            = 0
Min_Temp_Bit            = 0

A1                      = 0
'B1                      = 0

Restart_Requested       = 0


Channel                 = 5

Temp_Offset             = 1630
Temp_Offset2            = 1630

Temp_divider            = 60


Restart_Counter         = 0

Max_Temp                = 0
Min_Temp                = 65535

Data_Count_IN           = 0
Byte_Address            = 0
Temp                    = 0
Temp2                   = 0
Temp3                   = 0
Temp4                   = 0
Temp5                   = 0
Temp_Raw                = 0
Data_Counter            = 0

Digit_One               = 0
Digit_Two               = 0
Digit_Three             = 0

Digit_One_Temp          = 0
Digit_Two_Temp          = 0
Digit_Three_Temp        = 0

Settle_Counter          = 0

           

Temp_Divider_Float      = 0


Temp_Raw_Stack          = 0


Cycle_Speed             = 8

BaudDetected            = 0

Reading                 = 0

Buttons                 = 0

Unit                    = 1


String_Array_Sensor     = ""



Reading_Max             = 0
Reading_Min             = 9999999
Reading_Max2            = 0
Reading_Min2            = 9999999

Max_Length              = 0
Min_Length              = 0

Test_Flag               = 0

Data_Value              = 0

No_Connection_Counter   = 0
Connection_Counter      = 0

Print_Reading_Counter   = 0

Zero_Offset             = 0

Reading_Float           = - 1.2345 ' Make it something which is readable yet unlikely

Reading_Float_Zero      = 0
Reading_Float_Tare      = 0

Filter_Counter          = 0

Filter                  = 0


Out_of_Range_Counter    = 0


Seconds                 = 0
Minutes                 = 0

Firmware_Version        = "P1.5"


For A1 = 0 To 31                ' Clear arrays

       Data_In[A1] = 0
Next A1

For A1 = 0 To 19
    Sensor_Array[A1] = 0
Next A1

For A1 = 0 To 9
    Reading_Array[A1] = 0
Next A1
DATA_OUTPUT_STRING =  Firmware_Version + 13
GoSub DATA_OUT
'----------------------------------------------------------------------------------------------------------------------------------------***

MEASUREHART                    = 0
MEASURE24V                     = 0
MEASUREmA                      = 0
MEASUREmVRTD                   = 0
MEASURE34RDT                   = 0
AUX1TOP                        = 0
AUX2TOP                        = 0
AUX1BOTTOM                     = 0
AUX4TOP                        = 0
AUX3TOP                        = 0
AUX2BOTTOM                     = 0
MEASUREThermocouple            = 0
SOURCEThermocouple             = 0
SOURCEOhms                     = 0
SOURCEVmA                      = 0
AUX3BOTTOM                     = 0
AUX4BOTTOM                     = 0

LED                            = 1



Test_Loop:

        AUX2TOP = 0
        AUX2BOTTOM = 1
        HRSOut "Bottom",13
        DelayMS 1000
        AUX2TOP = 1
        AUX2BOTTOM = 0
        HRSOut "Top",13
        DelayMS 1000


GoTo Test_Loop
